/*!
 * Berrycake.js License (Issued February 22, 2024)
 * Copyright (c) Mizuna Shima
 * Website: https://lanama.net/scripts/berrycake/
 * 
 * Subject to the conditions set forth below, anyone who obtains a copy of this script is granted permission to use it for commercial and non-commercial purposes free of charge.
 * Please adhere to the following usage rules:
 * 1. When used commercially or redistributed, significant parts must include the author's credit and the official distributor.
 * 2. Do not remove the credits and license text within the file.
 * 3. Do not sell the script, nor any product primarily based on this script.
 * 4. Do not use the saved data from this script for monetary claims or requests for goods.
 * Even if the user modifies this script, these rules must be followed.
 * 
 * The author or copyright owner of this script shall not be liable for any damages or issues under any contract, tort, or other liabilities, in any case.
 */

// Berrycake ver 1.2

class Berrycake {

  // 名前リストのファイルパス
  static nameList = 'berrycake_recipe.conf';
  // 登録ボタンのid
  static setNameId = 'cakeSet';
  // 一時登録ボタンのid
  static setSessionId = 'cakeSession';
  // 削除ボタンのId
  static unsetNameId = 'cakeUnset';
  // 一時登録の表記をするid
  static viewRegistSession = 'cakeSessionmsg';
  // 一時登録の際に表示できるメッセージ
  static sessionString = '一時登録しました';
  // 部分的に置換したい範囲の指定id
  static targetAreaId = 'berrycake';
  // 部分的に置換したい範囲のclass
  // classの場合、複数あっても1つ目のタグ内のみが変換対象です。
  // 上記のidで範囲を取得できたときはこのclass指定は無効になります。
  static targetAreaClass = 'berrycake';
  // 登録フォームを自動で出力する場合の指定id
  static formTargetId = 'cakeMix';
  // 登録フォームをシンプルな構造で出力する場合の指定class
  static formPlainClass = 'plain';
  // 自動出力フォームの登録ボタンの文字
  static autoSetNameStr = '登録';
  // 自動出力フォームの削除ボタンの文字
  static autoUnsetNameStr = '削除';
  // 変換回避タグのclass
  static replaceSkipClass = 'no_cake';
  // 登録できる最大文字数
  // この文字数を超える文字は「…」として変換されます。この機能を使用しない場合は0を設定します。
  static maxSize = 50;
  // 名前登録時、ブラウザの設定で「Web Storage」が使えないときにウィンドウを出すかどうか
  // 出す場合は1を設定します。
  static showStorageError = 0;
  // 追加したい対象タグ
  // p, li, ruby, rt, h1, h2, h3, h4, a, span, divタグの他に対象にしたいタグがあればこちらに。
  // 思わぬ動作をするかもしれないので、追加した場合は念入りに動作確認してください。
  addTag = [
    '',
    '',
    '',
  ];
  // localStorageまたはsessionStorageの保存キー
  static storageKeyName = 'berrycake';
  // カスタム用class共通
  static customCommonStr = 'cake_custom_';
  // カスタム用記号共通
  static customSymbol = 'cake_custom_symbol';
  // カスタム用数値共通
  static customNum = 'cake_custom_num';
  
  /******** 以降の行はシステム部分のため、触らないでください ********/

  static replaceLimit=1e3;static customNumLimit=10;static customSymbolList=["……","ー","――","〰〰","〜","！","！　","、","。","・",",","，","☆","☆　","★","★　","♡","♡　","♪","♪　"];constructor(){this.mix={},this.cake={},this.label={},this.tmpBerrycake={},this.isSession=!1,this.cakeKeys={},this.targetNode=void 0,this.tags=["p","ruby","rt","h1","h2","h3","h4","h5","li","th","td","a","span","div",],this.regexPatterns={}}static async initialize(){let e=new Berrycake;try{let t=e.checkAndShowBeforeErr();if(t)throw Error(t);let a=Berrycake.getBerrycakeConfigPath(),r=await fetch(a);if(!r.ok)throw console.error("設定ファイルが読み込めません。"),Error(`HTTP error! status: ${r.status}`);let s=await r.text();e.setNameAndLabel(s),e.cakeKeys=Object.keys(e.mix),e.createMixForm()}catch(i){console.error("Error initializing Berrycake:",i)}return e}static getFormattedDate(){let e=new Date,t=e.getFullYear(),a=String(e.getMonth()+1).padStart(2,"0"),r=String(e.getDate()).padStart(2,"0");return`${t}${a}${r}`}static getBerrycakeConfigPath(){let e=Berrycake.getFormattedDate(),t=document.getElementsByTagName("script"),a="",r=/berrycake[^\/]*\.js/;for(let s of t){let i=s.src.match(r);if(i){a=s.src.replace(r,"")+Berrycake.nameList+`?date=${e}`;break}}return a}checkAndShowBeforeErr=()=>"file:"===window.location.protocol?(this.createWarn("サーバではなくパソコン上のファイルを読み込んでいます。\n動作確認はサーバ上で行ってください。（このメッセージはサーバ上では表示されません）"),"サーバ上で動作確認してください。"):this.isValidDomain()?null:(this.createWarn("設定ファイルは同一ドメインに配置してください。"),"設定ファイルは同一ドメインに配置してください。");isValidDomain=()=>{let e=Berrycake.nameList.startsWith("http://")||Berrycake.nameList.startsWith("https://");if(!e)return!0;let t=document.createElement("a");t.href=Berrycake.nameList;let a=window.location.hostname;return t.hostname===a};createWarn=e=>{let t=document.createElement("div");t.style.position="fixed",t.style.bottom="0",t.style.left="0",t.style.right="0",t.style.fontSize="12px",t.style.backgroundColor="rgb(220, 200, 100)",t.style.opacity=".8",t.style.padding="10px",t.style.textAlign="center",t.style.zIndex="1000",t.innerText=e,document.body.appendChild(t)};setNameAndLabel=e=>{let t=e.split("\n");t.forEach(e=>{let t=e.split("=");if(2!==t.length)return;let a="cake";if(t[0].includes(a)){let r=this.extractNumber(t[0].trim(),a);this.mix[`${a}${r}`]=t[1].replace(/[\r\n]+/g,"")}if(a="label",t[0].includes(a)){let s=this.extractNumber(t[0].trim(),a),i=t[1].replace(/[\r\n]+/g,"").slice(0,10);this.label[`${a}${s}`]=i}})};createMixForm=()=>{let e=new CreateMixForm(this.label,this.mix,Berrycake.formTargetId,this.extractNumber);e.generateForm()};extractNumber=(e,t)=>{let a;return"cake"===t&&(a=e.match(/cake(\d+)/)),"label"===t&&(a=e.match(/label(\d+)/)),a?a[1]:null};setTagTarget=()=>{(!Berrycake.targetAreaId||(this.targetNode=document.getElementById(Berrycake.targetAreaId),!this.targetNode))&&(!Berrycake.targetAreaClass||(this.targetNode=document.getElementsByClassName(Berrycake.targetAreaClass)[0],!this.targetNode))&&(this.targetNode=void 0)};addTagList=()=>{this.tags=this.tags.filter(e=>""!==e),this.addTag=this.addTag.filter(e=>""!==e),this.tags=[...this.tags,...this.addTag],this.tags=this.tags.map(e=>e.toUpperCase())};static async run(){try{let e=await Berrycake.initialize();return e.initializeRegexPatterns(),e.setTagTarget(),e.addTagList(),e.start(),e.viewName(),e}catch(t){console.error("Error in Berrycake.run:",t)}}initializeRegexPatterns(){for(let e in this.regexPatterns={},this.mix){let t=this.escapeRegExp(this.mix[e]);this.regexPatterns[e]=RegExp(t,"g")}}setFormName(e){let t=document.getElementById(e);t&&(t.value=this.cake[e])}setSessionMessage=()=>{let e=document.getElementById(Berrycake.viewRegistSession);if(e){if(!this.isSession){e.textContent="";return}e.textContent=Berrycake.sessionString}};replaceTextDetail(e){let t=e;for(let a of this.cakeKeys){let r=this.regexPatterns[a],s=this.cake[a];s&&(t=t.replace(r,s))}return t}escapeRegExp(e){return e.replace(/[.*+?^${}()|[\]\\]/g,"\\$&")}replaceText(e,t){let a=0,r=e=>{!(a>=t)&&e.childNodes.forEach(e=>{!(a>=t)&&!(e.nodeType===Node.ELEMENT_NODE&&e.classList.contains(Berrycake.replaceSkipClass))&&(e.nodeType===Node.TEXT_NODE&&this.tags.includes(e.parentNode.nodeName)?(e.textContent=this.replaceTextDetail(e.textContent),a++):e.nodeType===Node.ELEMENT_NODE&&r(e))})};r(e)}viewName=()=>{if(this.readName(),this.cake){if(this.targetNode){this.replaceText(this.targetNode);let e=new BerrycakeCustom(this.targetNode,this.tags,Berrycake.customNumLimit,Berrycake.customSymbolList,Berrycake.customCommonStr,Berrycake.customSymbol,Berrycake.customNum);e.applyHandlersToElements()}for(let t in this.cake)this.setFormName(t);this.setSessionMessage()}};readName=()=>{this.isSession=!1;let e=null,t;try{(e=JSON.parse(localStorage.getItem(Berrycake.storageKeyName)))||(e=JSON.parse(sessionStorage.getItem(Berrycake.storageKeyName)),this.isSession=!!e)}catch(a){if(this.isWebAPISupported=!1,t=Object.keys(this.tmpBerrycake),!e&&t.length<1)return!1;if(!e&&t.length>0)for(let r=0;r<t.length;r++){let s=this.cakeKeys[r];this.cake[s]=decodeURIComponent(this.tmpBerrycake[s])}return}if(null===e)return;let i=Object.keys(e);for(let l=0;l<i.length;l++){let c=`cake${this.extractNumber(i[l],"cake")}`;this.cake[c]=decodeURIComponent(e[c])}};unsetNameHandler=()=>{this.unsetStorage(),location.reload(!0)};unsetStorage=()=>{try{localStorage.removeItem(Berrycake.storageKeyName),sessionStorage.removeItem(Berrycake.storageKeyName)}catch(e){return!1}};setNameHandler=e=>()=>{this.setStorage(e)};setStorage(e=!0){let t={};for(let a=0;a<this.cakeKeys.length;a++){let r=this.cakeKeys[a],s=document.getElementById(r);if(!s||s.value.length<1)continue;let i=s.value;void 0!==Berrycake.maxSize&&0!==Berrycake.maxSize&&i.length>Berrycake.maxSize&&(i=i.slice(0,Berrycake.maxSize)+"…"),t[r]=this.tmpBerrycake[r]=encodeURIComponent(i)}try{let l=e?localStorage:sessionStorage,c=e?sessionStorage:localStorage;l.setItem(Berrycake.storageKeyName,JSON.stringify(t)),c.removeItem(Berrycake.storageKeyName),location.reload(!0)}catch(n){Berrycake.showStorageError&&alert("Web Storageが利用できません。ブラウザの設定を確認してください。")}}start=()=>{let e=[{id:Berrycake.setNameId,isLocalStorage:!0,handler:this.setNameHandler(!0)},{id:Berrycake.setSessionId,isLocalStorage:!1,handler:this.setNameHandler(!1)},{id:Berrycake.unsetNameId,isLocalStorage:null,handler:this.unsetNameHandler}];e.forEach(({id:e,handler:t})=>{let a=document.getElementById(e);a&&(a.removeEventListener("click",t,!1),a.addEventListener("click",t,!1))})}}class BerrycakeCustom{static customStrList=[{action:"first",handler:"changeFirst",isExclusive:!0},{action:"fold",handler:"changeFold",isExclusive:!0},{action:"split",handler:"changeSplit",isExclusive:!0},{action:"vowel",handler:"changeVowel",isExclusive:!0},{action:"vowel_min",handler:"changeVowelMin",isExclusive:!0},{action:"kana",handler:"changeKana",isExclusive:!1}];constructor(e,t,a,r,s,i,l){this.targetNode=e,this.tags=t,this.customNumLimit=a,this.customSymbolList=r,this.customCommonStr=s,this.customSymbol=i,this.customNum=l}applyHandlersToElements=()=>{BerrycakeCustom.customStrList.forEach(e=>{let t=this.targetNode.querySelectorAll("."+this.customCommonStr+e.action);t.forEach(t=>{let a=this.searchOption(t.classList),r=this[e.handler](t.textContent,a);t.textContent=r})})};extractOption=(e,t,a,r)=>{let s=Array.from(e).find(e=>e.startsWith(t))?.match(/\d+/),i=s?parseInt(s[0],10):null;return!r&&i>0&&i--,null!==i&&i>a&&(i=r?a:0),i};searchOption=e=>({numVal:this.extractOption(e,this.customNum,this.customNumLimit,!0),symbolVal:this.extractOption(e,this.customSymbol,this.customSymbolList.length-1,!1)});changeFirst=(e,t)=>{let a=this.nameSplit(e),r=t.numVal?t.numVal:1,s=a[0];for(let i=1;i<r&&(s+=a[i],!(i>=a.length-1));i++);return s};changeFold=(e,t)=>{let a=this.nameSplit(e)[0],r=t.numVal?t.numVal:1,s=a;for(let i=1;i<r;i++)s+=`、${a}`;return`${s}、`};changeSplit=(e,t)=>{let a=this.nameSplit(e),r=t.symbolVal?this.customSymbolList[t.symbolVal]:this.customSymbolList[0];return a.join(r)};changeVowel=(e,t)=>{let a=this.buildVowelString(e,t,!0);return a};changeVowelMin=(e,t)=>{let a=this.buildVowelString(e,t,!1);return a};buildVowelString=(e,t,a)=>{let r=e.slice(-1),s=VowelChecker.findRepresentative(r,a),i=t.numVal?t.numVal:1,l=s;for(let c=1;c<i;c++)l+=s;return l};changeKana=e=>e.replace(/[\u3041-\u3096]/g,e=>String.fromCharCode(e.charCodeAt(0)+96));nameSplit=e=>{let t=Array.from(e),a=[],r=/[ぁぃぅぇぉゕゖっゃゅょゎァィゥェォヵㇰヶㇱㇲッㇳㇴㇵㇶㇷㇸㇹㇺャュョㇻㇼㇽㇾㇿヮｧｨｩｪｫｬｭｮｯ・ー]/;for(let s=0;s<t.length;s++){let i=t[s];for(let l=s+1;l<t.length;l++)if(r.test(t[l]))i+=t[l],s++;else break;a.push(i)}return a}}class VowelChecker{static vowelsUppercase=["あ","ア","い","イ","う","ウ","え","エ","お","オ"];static vowelsLowercase=["ぁ","ァ","ぃ","ィ","ぅ","ゥ","ぇ","ェ","ぉ","ォ"];static vowels=[/[あかさたなはまやらわがざだばぱゃぁゕゎ]/,/[アカサタナハマヤラワガザダナパァヵㇵャㇻヮ]/,/[いきしちにひみりゐぎじぢびぃヰ]/,/[イキシチニヒミリギジヂビィㇱㇶㇼ]/,/[うくすつぬふむゆるぐずづぶぷゅぅっ]/,/[ウクスヌヌフムユルグズヅブプュゥㇰㇲッㇴㇷㇽ]/,/[えけせてねへめれゑげぜでべぺぇゖ]/,/[エケセテネヘメレゲゼデベペェヶㇸㇾ]/,/[おこそとのほもよろをごぞどぼぽょぉ]/,/[オコソトノホモヨロヲゴゾドボポョォㇳㇹㇺㇿ]/,/[んー〜ン]/,];static findRepresentative=(e,t=!0)=>{let a=null;if(this.vowels.forEach((t,r)=>{t.test(e)&&(a=r)}),a==this.vowels.length-1)return e;if(null===a)return"";let r=t?VowelChecker.vowelsUppercase[a]:VowelChecker.vowelsLowercase[a];return r}}class CreateMixForm{constructor(e,t,a,r){this.elementLabels=e,this.inputProperties=t,this.targetDiv=document.getElementById(a),this.extractNumber=r}generateFormElements=()=>{let e=this.targetDiv.classList.contains(Berrycake.formPlainClass);Object.keys(this.inputProperties).forEach(t=>{let a=this.extractNumber(t,"cake"),r=`label${a}`,s=this.escapeHTML(this.elementLabels[r])||"",i=`<label for="${t}">${s}</label><input type="text" id="${t}" value="">`;if(e)this.targetDiv.innerHTML+=i;else{let l=document.createElement("div");l.className="row",l.innerHTML=i,this.targetDiv.appendChild(l)}})};addButtons=()=>{let e=[{id:Berrycake.setNameId,text:Berrycake.autoSetNameStr},{id:Berrycake.unsetNameId,text:Berrycake.autoUnsetNameStr}],t=document.createElement("div");t.className="row",e.forEach(e=>{let a=document.createElement("button");a.id=e.id,a.textContent=e.text,t.appendChild(a)}),this.targetDiv.appendChild(t)};escapeHTML=e=>e.replace(/[&<>"']/g,function(e){switch(e){case"&":return"&amp;";case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&#39;";default:return e}});generateForm(){this.targetDiv&&(this.generateFormElements(),this.addButtons())}
}

try {
  Berrycake.run();
} catch (error) {
  console.error("An error occurred while creating a Berrycake instance: ", error);
}